package weaver.interfaces.seclinktel.crob;

import com.weaver.general.Util;
import weaver.conn.RecordSet;
import weaver.interfaces.schedule.BaseCronJob;
import weaver.interfaces.seclinktel.entity.po.EducationModePo;
import weaver.interfaces.seclinktel.entity.po.WorkInfoModePo;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Optional;
import java.util.function.BinaryOperator;
import java.util.function.Function;
import java.util.stream.Collectors;

/**
 * @Author liang.cheng
 * @Date 2024/11/5 4:10 PM
 * @Description: TODO
 * @Version 1.0
 */
public class ResourcePersonInfoCron extends BaseCronJob {
    @Override
    public void execute() {

        RecordSet rs = new RecordSet();
        //1.工作经历
        List<WorkInfoModePo> workInfos = new ArrayList<>();
        rs.executeQuery("select xm,qgslzsj,gsmc,zw1 from uf_gzjl");
        while (rs.next()) {
            Integer userId = Util.getIntValue(rs.getString("xm"));
            String lastCompanyLeaveDate = Util.null2String(rs.getString("qgslzsj"));
            String lastWorkunitName = Util.null2String(rs.getString("gsmc"));
            String lastJobName = Util.null2String(rs.getString("zw1"));
            workInfos.add(WorkInfoModePo.builder().userId(userId).lastCompanyLeaveDate(lastCompanyLeaveDate).lastWorkunitName(lastWorkunitName).lastJobName(lastJobName).build());
        }

        List<WorkInfoModePo> workResult = new ArrayList<>(workInfos.stream()
                .filter(workInfo -> workInfo.getLastCompanyLeaveDate() != null)
                .collect(Collectors.toMap(
                        WorkInfoModePo::getUserId,
                        Function.identity(),
                        BinaryOperator.maxBy(Comparator.comparing(WorkInfoModePo::getLastCompanyLeaveDate))))
                .values());

        //2.教育经历第一学历

        List<EducationModePo> educationFirst = new ArrayList<>();
        rs.executeQuery("select xm,xl,zy from uf_jxjl where sfwdyxl = 0");
        while (rs.next()) {
            Integer userId = Util.getIntValue(rs.getString("xm"));
        }



        //2.教育经历最高学历
        List<EducationModePo> educationHighest = new ArrayList<>();
        rs.executeQuery("select xm,xl,zy from uf_jxjl where sfwzgxl = 0");
        while (rs.next()) {

        }



    }
}
